﻿using Syncfusion.UI.Xaml.Controls.Data;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TextBoxExt
{
    public class TextBoxExtProperties : NotificationObject, IDataValidation
    {
        private ObservableCollection<string> listOfName;
        public ObservableCollection<string> ListOfName
        {
            get { return listOfName; }
            set { listOfName = value; }
        }

        private string name;
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); RaisePropertyChanged("Error"); }
        }
               
        public string Error
        {
            get
            {
                if (listOfName.IndexOf(Name) != -1)
                    return "Duplicate";
                else
                    ListOfName.Add(Name);
                return "";
            }
        }


        public string this[string columnname]
        {
            get
            {
                switch (columnname)
                {
                    case "Name":                        
                        if (listOfName.IndexOf(Name) != -1)
                            return "Duplicate";
                        else
                            ListOfName.Add(Name);
                        break;                    
                }
                return "";
            }
        }
        public TextBoxExtProperties()
        {
            listOfName = new ObservableCollection<string>();
        }       
    }

    public class NotificationObject : INotifyPropertyChanged
    {
        public void RaisePropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
